/*
 * File:   tesla_charge_monitor_p18.c
 * Author: suxxer
 *
 */

//#include <p18cxxx.h>
#include <htc.h>

// Using Internal Clock of 20 Mhz
#define FOSC 20000000L

// define bit manupulation & test functions
#define bit_set(var,bitno) ((var) |= 1 << (bitno))
#define bit_clr(var,bitno) ((var) &= ~(1 << (bitno)))


// Delay function, done.
void _delay_us(int x) {
    unsigned char _us;
    _us = (x)/(12000000/FOSC)|1;
    while(--_us != 0) continue;
 }
// Delay function, done.
void _delay_ms(unsigned int ms) {
    unsigned char i;
    do {
        i = 4;
        do {
        _delay_us(164);
        } while(--i);
    } while(--ms);
}

// Function prototypes.
void main_loop(void);
void UART_RX(void);
void M_timeout(void);
void Handle_CAN(void);
void GSM_IO(void);
void ID_96A(void);
void SMS_Stopped(void);

// Variable definitions
int Stopped;
int Charging;
int UartCount;
int GSM_State;
int y;
int z;
int DataLength;
int DATAB1;
int DATAB2;
int DATAB3;
int DATAB4;
int DATAB5;
int DATAB6;
int DATAB7;
int DATAB8;
int LineVoltageL;
int LineVoltageH;
int ChargeCurrent;
int IdealRangeL;
int IdealRangeH;
int EstRangeL;
int EstRangeH;
int ChargeState;
int ChargeMode;
int Charging;
int Stopped;
int Doors;
int SOC;
int AccessPIN = 1234;
char RegPhoneNr[30] = "+31123456789";
char AT[5] = "AT\r";
char CPIN[10] = "AT+CPIN?\r";
char CREG[10] = "AT+CREG?\r";
char CLIP[11] = "AT+CLIP=1\r";
char CMGF[11] = "AT+CMGF=1\r";
char CNMI[13] = "AT+CNMI=2,2\r";
char CSDH[11] = "AT+CSDH=0\r";
char CMGS[11] = "AT+CMGS=\""; //; Start of SMS status message
char Mode_Standard[50] = "Standard - ";
char Mode_Storage[50] = "Storage - ";
char Mode_Range[50] = "Range - ";
char Mode_Performance[50] = "Performance - ";
char State_Charging[50] = "Charging";
char State_ToppingOff[50] = "Charging, Topping off";
char State_Done[50] = "Charging Done";
char State_Stopped[50] = "Charging Stopped";
char StateOfCharge[10] = " SOC: ";
char Kilometer[10] = " Km";		// comment this line if you want to use Miles
//Miles = " mi"                                 // maybe we have to solve this different?
char IdealRange[30] = "\rIdeal Range ";




// Main function and definitions, done.
void main(void) {
 // I/O configuration PORT A
PORTA=0;	//Initialise port A
ADCON1=0x0F; //Switch off A/D converter

//I/O configuration PORT B
TRISB=0xFF;

//I/O configuration PORT C

TRISC=	0b10000000; // Port C RC0-6 output, RC7 input
PORTC=0; // Initialise PORT C
T0CON = 0b10000111; // Timer 0 enabled, Fosc/4, 16 bit mode, prescaler 1:256 @ 5Mhz => 51,2 uS

// Initialize CAN
CANCON=0b10010000;

//ConfigWait and  Check bit 7 (OPMODE2). Dont use Access bank
while(!(CANSTAT & 0b10000000)){
// Wait for Configuration mode
}

RXB0CON = 0x000; // Receive all valid messages
RXF0SIDL = 0x000; // Setup Filter and Mask so that only CAN ID 0x100 will be accepted
RXF0SIDH = 0x100; //Set Filter to 0x100

RXM0SIDL = 0x007; // Set Mask to 0x7ff ( 7 decimal)
RXM0SIDH = 0xFF; // (255 decimal)

BRGCON1 = 0x00; // Set Baudrate to 1 Mbps (00000000)
BRGCON2 = 0xD2;
BRGCON3 = 0x02;

CIOCON = 0b00100000; // CANTX pin will drive VDD when recessive (Bit 5 = 1)
CANCON = 0b01100000; // Listen only mode, Receive bufer 0

SPBRGH = 0x00 ; // Baudrate 115.2
SPBRG = 0x2A; //
BAUDCON = 0b00100100; // 16 bit Baudrate register is used
TXSTA = 0b00100100; // Enable TX, 8 bit, Asynchronous mode
RCSTA = 0b10010000; // Enable serial port TX and RX, 8 bit.

Stopped=0;
Charging=0;
UartCount=0;
GSM_State=0;

// LED=1 LED On Bit4
bit_set(PORTC,4);
//_delay_ms(10000); //Wait 10 seconds ; and give GSM modem time to boot up.
_delay_ms(10); //for testing
// LED=0 LED Off Bit4
bit_clr(PORTC,4);

while(1){
main_loop(); // Loop main_loop() until death.
}
return;
}

void main_loop(void) {
    
    if(PIR1 & (1<<5)) { // PIR1,RCIF = Bit 5 of PIR1 (Check if the EUSART receive buffer, RCREG, is full =1)
		UART_RX(); // Uart Reception
	} else {
		if(RCSTA & (0<<1)) { //Uart Overrun Error ? ; RCSTA,OERR = Bit 1 of RCSTA  (1 = Overrun error)
		M_timeout(); // No overrrun
		} else { //yes, Stop Uart reception
		bit_clr(RCSTA,4); // Set RCSTA,CREN = Bit 4 of RCSTA to 0 (0 = Disables receiver)
		bit_set(RCSTA,4); // restart Uart RX; Set RCSTA,CREN = Bit 4 of RCSTA to 1 (1 = Enables receiver)
                M_timeout();
		}

	}
   
}

//Uart receive function: not done
void UART_RX(void) {
    // to be coded...
    return;
}


//Timeout function, done.
void M_timeout(void) {
y=TMR0L; // MSB of timer 0 is only updated after a read of TMR0L, needed in C?
    if(TMR0H & (1<<7)){
        // _delay_ms(1500); // timeout ~1,5 sec send AT command again
        _delay_ms(10); //for testing
        GSM_State=0;
    }
GSM_IO(); // Handle GSM commands
    if(RXB0CON & (1<<7)){ //check RXB0CON Bit 7 (RXFUL) = 1 ; Does RXB0 contain a CAN message?
        return; // No. Check again
    } else {
        Handle_CAN();
        return;
    }
return;
}

// Can handle function, done.
void Handle_CAN(void){
    //Decode CAN message
    //We check for sub message ID's (byte B1) 0x95, 0x96, 0x80, 0x88, 0x89
    y=RXB0DLC;
    z=0x0F;
    DataLength = y & z ;
    DATAB1=RXB0D0;
    DATAB2=RXB0D1;
    DATAB3=RXB0D2;
    DATAB4=RXB0D3;
    DATAB5=RXB0D4;
    DATAB6=RXB0D5;
    DATAB7=RXB0D6;
    DATAB8=RXB0D7;
    
    bit_clr(RXB0CON, 7); //clear RXFUL (Bit 7) of RXB0CON
    bit_clr(PORTC,4); // LED OFF

    if(DATAB1==89) { // Charging Voltage / Iavailable
        LineVoltageL=DATAB3;
        LineVoltageH=DATAB4;
        return;
    }
     if(DATAB1==88) {    // Charging Current / Duration
        ChargeCurrent=DATAB2;
        return;
    }
     if(DATAB1==80) { // Range / State of Charge
         bit_set(PORTC,4); //LED ON; ; SOC update indicated with LED
        SOC=DATAB2;
        IdealRangeL=DATAB3;
        IdealRangeH=DATAB4;
        EstRangeL=DATAB7;
        EstRangeH=DATAB8;
        return;
    }
     if(DATAB1==95) { // Charging mode
        ChargeState=DATAB2;
        DATAB6 = (DATAB6 >> 4) | (DATAB6 << 4); // SWAPF DATAB6
       // ChargeMode=DATAB5 & 0x0F; // 2008 Roadsters
        ChargeMode=DATAB6 & 0x0F; // 2010 Roadsters
        if (Stopped == 0){ // Charging stopped?
            SMS_Stopped(); // Send Message to roadster owner(s)
        }
        return;
    }
     if(DATAB1==96) { // Doors / Charging yes/no
         if(Charging == 0){ // Already Charging?
             if (DATAB4==4){ //  Yes, charging. Change to not charging?
                 ID_96A(); // No, or no change
             } else {
                 Stopped=1; // Set flag
             }

         }
         Doors = DATAB2;
        return;
    }
            
    return;
}

// CAN 96A handler, done.
void ID_96A(void){
    DATAB2 = (DATAB2 >> 4) | (DATAB2 << 4); // Check bit 4 to check charging status
    Charging = DATAB2 & 0x01; // Update register
    return;
}


//GSM IO function, not done.
void GSM_IO(){
    // to be coded.
    return;
}

// SMS Stopped Function, not done.
void SMS_Stopped(){
    //to be coded.
    return;
}




